C
C	PROGRAM DIF   IS CURRENTLY UNDER RECONSTRUCTION!
C	AND AT THE MOMENT CALCULATES ONLY DIFFUSION COEFFICIENTS,
c	DIFFUSION VELOCITIES AND WEIGHTED MEAN RAD.ACCELERATIONS
C
C-----------------------------------------------------------------------
C          THE CODE CALCULATES ION DIFFUSION VELOCITIES AS A RESULT
C	OF THE RADIATIVE ACCELERATION, ..., AND SOLVES THE STEADY
C	STATE - THE VERTICAL STRATIFICATION OF AN ELEMENT IN 
C	THE ATMOSPHERE UNDER THE ASSUMPTION OF ITS CONSTANT PARTICLE 
C	FLUX USING THE RUNGE-KUTTA METHOD.
C
C       INPUT:	
C               element.dat  - (7) ATOMIC DATA FOR THE CHEM.ELEMENT
C               model.hub - (3) HUBENY'S ATMOSPHERE MODEL 
C               accel.tot - (99) TOTAL ACCELERATION FOR EACH ION AND
C                                ABUNDANCE 
C       OUTPUT:	dif.out -(2) MORE DETAILED OUTPUT
C		accel.sum -(10) Di*Ni WEIGHTED RADIATIVE ACCELERATION
C		accel.sum2 -(11) Ni WEIGHTED RADIATIVE ACCELERATION
C
C       NOTE:
C		?? - PLACE OF ATTENTION OR POSSIBLE FAILURE
C		IF NOT SPECIFIED OTHERVISE CGS UNITS ARE USED
C           	Z AXIS IS DIRECTED TOWARDS THE STAR CENTRE;
C               NDIM - MAIN DIMENSION PARAMETER (AFTER INTERPOLATION)
C               NDIM1 - FIRST DIMENSION PARAMETERED FOR INPUT MODEL
C		NION1 - NUMBER OF IONS DIMENSION
C		NAB1 - NUMBER OF ABUNDANCES DIMENSION
C		DEFINITION OF ABUNDANCES:
C		    A=ELEMENT NUMBER DENS/ALL ATOM NUMBER DENSITY
C	WHAT TO IMPROVE:
C		WMM-MEAN ATOM MASS CALCULATION
C
C-----------------------------------------------------------------------
        PARAMETER(NDIM=900,NDIM1=900,NION1=9,NAB1=10)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION ZIP(NION1-1),STA(6,NION1),STAVS(NDIM,NION1)
     P  ,RION(NION1),R1(NION1),RR(NDIM,NION1),GRR(NDIM,NION1)
     P  ,TPG(NDIM,NION1),DI(NDIM,NION1)
     P  ,VI(NDIM,3),POM(NION1),POM2(NAB1),POM3(NAB1)
     P  ,HLB(NDIM),DM(NDIM),EKONC(NDIM),AKONC(NDIM),PRESS(NDIM)
     P  ,TEMP(NDIM),DENS(NDIM),VT(NDIM)
     P  ,VHLB(NDIM1),VDENS(NDIM1),VAKONC(NDIM1),VEKONC(NDIM1)
     P  ,VPRESS(NDIM1),VTEMP(NDIM1),VDM(NDIM1),ABROSS(NDIM1),VVT(NDIM1)  
     P  ,TOK(NDIM,3)
     P  ,YPS(NDIM),GAA(NDIM),GAK(NDIM),GRADN(NDIM1,NION1,NAB1)
     P  ,ABUND(NAB1),GRAD0(NDIM1,NION1),WGRADN(NAB1)
     P  ,ALF(NDIM),BET(NDIM),GAM1(NDIM)
     P  ,STAHI(6,2),STAHEI(6,3),HIS(2),HEIS(3),HI(NDIM),HEI(NDIM)
        CHARACTER*30 INMOD,INRAD
C        SAHA EQUATION (RATIO OF NUMBER DENSITIES OF TWO ADJACENT IONS)
C             ZP -IN [EV],BOLT.CONST.-IN [ERG/K]
C        SAHA(TE,EK,ZP,S1,S2)=1.2020D9*S2/(S1*(5039.77D0/TE)**2.5D0
C     P  *DEXP(2.302585D0*5039.77D0/TE*ZP)*EK*TE*1.38062D-16)
C-----------------------------------------------------------------------
        WRITE(6,'(A)')' DIF'
        WRITE(6,'(A)')'       INPUT:'	
        WRITE(6,'(A)')' element.dat - (7) ATOMIC DATA FOR THE ELEMENT'
        WRITE(6,'(A)')' model.hub - (3) HUBENY ATMOSPHERE MODEL' 
        WRITE(6,'(A,A)')' accel.tot - (99) ACCELERATION FOR EACH ION'
     P  ,' AND ABUNDANCE' 
        WRITE(6,'(A)')'       OUTPUT:'
        WRITE(6,'(A)')' dif.out - (2) MORE DETAILED OUTPUT'
        WRITE(6,'(A,A)')' accel.sum -(10) Di*Ni WEIGHTED'
     P  ,' RADIATIVE ACCELERATION'
        WRITE(6,'(A,A)')' accel.sum2 -(11) Ni WEIGHTED RADIATIVE'
     P  ,' ACCELERATION'
C       CONSTANTS AND UNITS FROM NIST(2002)
        BOL=1.3806503D-16
        CLIGHT=2.99792458D10
        HJED=1.66053873D-24
        PLANK=6.62606876D-27
        PI=3.14159265358D0
	RGASS=8.314472D7
	AVOG=6.02214199D23
C       1EV=X ERG, X CM^-1; 1ERG= X CM^-1
        EVERG=1.602176462D-12
        EVCM=8.06554477D3
        ERGCM=5.03411762D15
C        CVL=2.997925D10
C        C=2.997925D10??
C        WRITE(6,'(A,$)')' INPUT MODEL: HUBENY [1], KURUCZ [0],',
C	 ' FERNANDES [2] => '
C        READ(5,*)IMODEL
	IMODEL=1
C	IMODEL=2
C        WRITE(6,'(A,$)')' FILE WITH THE MODEL => '
C        READ(5,'(A30)')INMOD
	INMOD='model.hub'
C        INMOD='model.ss'
C
C             NMOD - NUMBER OF ATMOSPHERE MODEL DEPTH POINTS
C             INTERP - NUMBER OF POINTS YOU WANT TO INTERPOLATE AND PUT 
C		BETWEEN TWO ORIGINAL DEPTH POINTS
C             INTERP=0, NBOD=NMOD - IF NO INTERPOLATION
C             NBOD=NMOD+(NMOD-1)*INTERP - NUMBER OF DEPTH POINTS IN 
C		NEW INTERPOLATED MODEL
C             NABUND - NUMBER OF ABUNDANCES FOR WHICH YOU HAVE 
C		THE RADIATIVE ACCELERATIONS
C             ABUND - ELEMENT ABUNDANCES CORRESPONDING TO THESE 
C		RADIATIVE ACCELERATIONS
C-----------------------------------------------------------------------
C             MODEL OF THE ATMOSPHERE 
C
C       DM - MASS DEPTH COORDINATE
C	HLB - GEOMETRICAL DEPTH
C       TEMP - TEMPERATURE
C       PRESS - GASS PRESSURE
C       EKONC - ELECTRON NUMBER DENSITY
C       AKONC - (ALL) ATOM NUMBER DENSITY
C	DENS - DENSITY
C
        IF (IMODEL.EQ.1) THEN
C             HUBENY MODEL OF THE ATMOSFERE
C          INMOD='model.hub'
          CALL HMODEL(INMOD,NDIM1,NMOD,TEFF,GLOG  
     P    ,VDM,VHLB,VTEMP,VPRESS,VEKONC,VAKONC,VDENS)
        ENDIF
        IF (IMODEL.EQ.0) THEN
C             KURUCZ MODEL OF THE ATMOSFERE
C          INMOD='model'
          CALL AMODEL(INMOD,NDIM1,NMOD,TEFF,GLOG
     P    ,VDM,VHLB,VTEMP,VPRESS,VEKONC,ABROSS,VAKONC,VDENS)
        ENDIF
        IF (IMODEL.EQ.2) THEN
C             FERNANDES MODEL OF THE STAR
C          INMOD='model.ss'
          CALL SSMODEL(INMOD,NDIM1,NMOD,TEFF,GLOG  
     P    ,VDM,VHLB,VTEMP,VPRESS,VEKONC,VAKONC,VDENS)
        ENDIF
C        GLOG=DEXP(GLOG*2.302585D0)
        OPEN(7,FILE='element.dat',STATUS='OLD')
        OPEN(2,FILE='dif.out',STATUS='UNKNOWN')
C-----------------------------------------------------------------------
C
C       IZMAZ - DUMMY
C       INTERP - INTERPOLATION 
C       NABUND - NUMBER OF ABUNDANCES
C       ABUND - ABUNDANCES FOR WHICH THE ACCELERATIONS ARE CALCULATED
C       NION - NUMBER OF IONS FOR WHICH THE ACCELERATIONS ARE CALCULATED
C       ABHYD - H ABUNDANCE, ABHEL - He ABUNDANCE
C       IVTURB - OPTION FOR DIF. KOEF. OF A TURBULENCE:
C                                       0-HOMOGENEOUS
C                                       1-OPTIONAL IN EACH DEPTH POINT
C                                       2-AS A 1/(GASS NUMBER DENSITY)
C       VT - VELOCITY OF THE TURBULENCE [CGS]
C       IAT - ELEMENT ATOM NUMBER, HMC - MASS NUMBER
C       ZIP - FIRTS 8 IONIZATION POTENTIALS
C       IPART - OPTION OF PARTITION FUNCTION
C               [1-BUIT IN DWORETSKY&SMALLEY, 2-IRWIN]
C       STA - PARTITION FUNCTION COEFFICIENTS FOR 8+1 STATES
C               AFTER IRWIN, 1981, ApJS 45,621
C             ABP - HOMOGENEOUS REFERENCE ELEMENT ABUNDANCE (E.G. SOLAR)
C             FREE PARAMETERS AT THE BOTTOM OF THE ATMOSPHERE:
C               GPA - GRADIENT OF THE ELEMENT ABUNDANCE
C		POCAB - ELEMENT ABUNDANCE
C	      POLAR - POLARIZABILITY OF NEUTRAL ATOM	
C             RATOM - NEUTRAL ATOM RADIUS  
        READ(7,'(/)')
        READ(7,*)IZMAZ,INTERP,NABUND,NION
        IF(NION.GT.NION1)THEN
          WRITE(6,*)' ERROR, TOO MANY IONIZATION DEGREES CONSIDERED'
          STOP
        ENDIF
        READ(7,*)
C        INTERP=0
        READ(7,*)(ABUND(I),I=1,NABUND)
        READ(7,*)
        READ(7,*)ABHYD,ABHEL
        READ(7,*)
        READ(7,*)IVTURB
        READ (7,*)
        IF(IVTURB.EQ.0)THEN
          READ(7,*)VT00
          DO 10 I=1,NMOD
            VVT(I)=VT00
10        CONTINUE
        ENDIF
        IF(IVTURB.EQ.1)THEN
          READ(7,*)(VVT(I),I=1,NMOD)
        ENDIF
        IF(IVTURB.EQ.2)THEN
          READ(7,*)VVT(1)
        ENDIF
        READ(7,*)
        READ(7,*)IAT,HMC
        PCP=IAT
        READ(7,*)
        READ (7,*)(ZIP(I),I=1,NION-1)
        READ(7,*)
        READ(7,*)IPART
        READ(7,*)
        DO 20 J=1,NION1
         READ (7,*)(STA(I,J),I=1,6)
20      CONTINUE
        READ (7,'(///)')
        READ (7,*)ABP
        READ(7,*)
        READ (7,*)GPA,POCAB
        READ(7,*)
        READ (7,*)POLAR,RATOM
        CLOSE(7)
        IF(DABS(ABHEL-0.089D0).GT.0.02D0.OR.
     P    DABS(ABHYD-0.911D0).GT.0.02D0) THEN
          WRITE(6,*)' WARNING: ABNORMAL H OR HE ABUNDANCE!
     P    YOU HAVE TO CHECK IF THIS IS IN AGREEMENT WITH
     P    THE MODEL USED AS THESE ABUNDANCES AFFECT THE MODEL AND E.G.
     P    THE CALCULATION OF NUMBER
     P    DESITY FROM DENSITY IN THE CODE
     P    NORMAL H AND HE ABUNDANCES ARE 0.9 AND 0.1, RESPECTIVELY'
          PAUSE
        ENDIF
C		TURBULENT VELOCITY AS A 1/ATOM NUMBER DENSITY
        IF(IVTURB.EQ.2)THEN
          DO 30 I=1,NMOD
            VVT(I)=VVT(1)*VAKONC(1)/VAKONC(I)
30        CONTINUE
        ENDIF
	WRITE(2,35)IAT,HMC,NION
35 	FORMAT('ELEMENT NO.=',I3,'   ELEMENT MASS NO.=',F7.3,
     P  '    NO. OF IONS CONSIDERED=',I2)
C-----------------------------------------------------------------------
C          WRITE(2,'(A,A)')' VDM      VHLB     VTEMP    VPRESS   VAKONC'
C     P    ,'   VEKONC   VDENS    VVT'
C        DO 40 I=1,NMOD
C          WRITE(2,45)VDM(I),VHLB(I),VTEMP(I),VPRESS(I),VAKONC(I),
C     P    VEKONC(I),VDENS(I),VVT(I)
C40      CONTINUE
C45      FORMAT(8E9.3)
C-----------------------------------------------------------------------
C             ADDING SOME MORE POINTS BETWEEN THE MODEL POINTS
C	USING THE HERMIT POLYNOM INTERPOLATION
        NBOD=NMOD+(NMOD-1)*INTERP
	IF(NBOD.GT.NDIM)WRITE(6,*)' ERROR IN DIMENZATION'
        IF (INTERP.EQ.0) THEN
          DO 50 I=1,NBOD
            DM(I)=VDM(I)
            HLB(I)=VHLB(I)
            PRESS(I)=VPRESS(I)
            TEMP(I)=VTEMP(I)
            AKONC(I)=VAKONC(I)
            EKONC(I)=VEKONC(I)
            DENS(I)=VDENS(I)
            VT(I)=VVT(I)
50        CONTINUE
	ELSE
	  CALL AINTEP(NMOD,NBOD,INTERP,DM,VDM,HLB,VHLB,TEMP,VTEMP
     P    ,PRESS,VPRESS,AKONC,VAKONC,EKONC,VEKONC,DENS,VDENS,VT,VVT)
        ENDIF
          WRITE(2,'(2A)')'  DM        HLB       TEMP      PRESS     '
     P    ,'AKONC     EKONC     DENS      VT'
        DO 60 I=1,NBOD
          WRITE(2,70)DM(I),HLB(I),TEMP(I),PRESS(I),AKONC(I)
     P    ,EKONC(I),DENS(I),VT(I)
60      CONTINUE
70      FORMAT(8E10.3)
C-----------------------------------------------------------------------
C             GTT- LOGARITMIC TEMPERATURE GRADIENT 
C	      GPP- LOGARITMIC PRESSURE GRADIENT
C             TPG(I,J)-TEMPERATURE AND PRESSURE TERMS IN THE DIFF. EQ.
C                TERMAL DIFFUSION OF NEUTRALS = 0
C	IF THE GRADIENTS ARE STRONG YOU SHOULD USE E.G.:
C            GTT=BLB1(DLOG(TEMP(1)),HLB(1),DLOG(TEMP(2)),HLB(2),
C     P      DLOG(TEMP(3)),HLB(3))
C-----------------------------------------------------------------------
        DO 100 I=1,NBOD
	  IF(I.EQ.1)THEN
            GTT=BLB1(TEMP(1),HLB(1),TEMP(2),HLB(2),TEMP(3),HLB(3))
     P      /TEMP(1)
            GPP=BLB1(PRESS(1),HLB(1),PRESS(2),HLB(2),PRESS(3),HLB(3))
     P      /PRESS(1)
	    GOTO 80
	  ENDIF
	  IF(I.EQ.NBOD)THEN
            GTT=BLB2(TEMP(NBOD-2),HLB(NBOD-2),TEMP(NBOD-1)
     P      ,HLB(NBOD-1),TEMP(NBOD),HLB(NBOD))/TEMP(NBOD)
            GPP=BLB2(PRESS(NBOD-2),HLB(NBOD-2),PRESS(NBOD-1)
     P      ,HLB(NBOD-1),PRESS(NBOD),HLB(NBOD))/PRESS(NBOD)
	    GOTO 80
	  ENDIF
          GTT=BLB(TEMP(I-1),HLB(I-1),TEMP(I),HLB(I),TEMP(I+1)
     P    ,HLB(I+1))/TEMP(I)
          GPP=BLB(PRESS(I-1),HLB(I-1),PRESS(I),HLB(I),PRESS(I+1)
     P    ,HLB(I+1))/PRESS(I)
80        CONTINUE
	  DO 90 J=1,NION
	    ZIK=DBLE(J)   
            TPG(I,J)=(2.54*(ZIK-1.)*(ZIK-1.)+0.805*
     P      (HMC-ZIK+1.))*GTT+(2.*HMC-ZIK)*GPP
90        CONTINUE
100     CONTINUE
C-----------------------------------------------------------------------
C             PARTITION FUNCTIONS AT DIFFERENT DEPTHS
C             STAVS(I,J) :  I-DEPTH POINT, J- ION
        IF(IPART.EQ.1)THEN
          CALL PFDWOR(NDIM,NBOD,NION1,NION,IAT,TEMP,EKONC,STAVS)
        ELSE
          CALL PFIRW(NDIM,NBOD,NION1,NION,STA,TEMP,STAVS)
        ENDIF
C-----------------------------------------------------------------------
C               POLYNOMIAL PARTITION FUNCTION COEFFICIENTS FOR
C               HI,HII   A    HEI,HEII,HEIII
        DATA STAHI/-2.61655891D2,1.63428326D2,-4.06133526D1,5.03282928D0
     P   ,-3.10998364D-1,7.66654594D-3,0.0D0,0.0D0,0.0D0,0.0D0,0.0D0
     P   ,0.0D0/
        DATA STAHEI/-3.76575219D-1,2.33951687D-1,-5.79755525D-2
     P   ,7.16333160D-3,-4.41302573D-4,1.08442997D-5,6.93147179D-1
     P   ,9.29636701D-10,-2.30049742D-10,2.83829746D-11,-1.74590774D-12
     P   ,4.28355287D-14,0.0D0,0.0D0,0.0D0,0.0D0,0.0D0,0.0D0/
C-----------------------------------------------------------------------
        WRITE(2,*)' AKONC     HI        HeI   (NUMBER DENSITY)'
        DO 200 ID1=1,NBOD
          SALA=DLOG(TEMP(ID1))   
C               HIS - H PARTITION FUNCTION
          DO 150 J=1,2
            HIS(J)=DEXP(STAHI(1,J)+STAHI(2,J)*SALA+STAHI(3,J)*SALA**2.D0
     P      +STAHI(4,J)*SALA**3.D0+STAHI(5,J)*SALA**4.D0
     P      +STAHI(6,J)*SALA**5.D0)
150       CONTINUE
C               HEIS - HE PARTITION FUNCTION 
          DO 160 J=1,3
            HEIS(J)=DEXP(STAHEI(1,J)+STAHEI(2,J)*SALA+STAHEI(3,J)
     P      *SALA**2.D0+STAHEI(4,J)*SALA**3.D0+STAHEI(5,J)*SALA**4.D0
     P      +STAHEI(6,J)*SALA**5.D0)
160       CONTINUE
C               HI - HI NUMBER DENSITY
C               HEI - HeI NUMBER DENSITY
          HI(ID1)=1.D0/(1.D0+SAH(TEMP(ID1),EKONC(ID1),13.598D0,HIS(1)
     P    ,HIS(2)))*AKONC(ID1)*ABHYD
          HEI(ID1)=1.D0/(1.D0+SAH(TEMP(ID1),EKONC(ID1),24.587D0,HEIS(1)
     P     ,HEIS(2))*(1.D0+SAH(TEMP(ID1),EKONC(ID1),54.416D0,HEIS(2)
     P     ,HEIS(3))))*AKONC(ID1)*ABHEL
        WRITE(2,'(3E10.3)')AKONC(ID1),HI(ID1),HEI(ID1)
200     CONTINUE
C-----------------------------------------------------------------------
C       RR(I,J)- POPULATION OF THE J-TH ION/TOTAL ELEMENT POPULATION
C		 AT I-TH DEPTH
C	R1(J)= N(J)/N(1)
C	RION(J)= N(J)/N(J-1)
C
C	DI(I,J) -DIFFUSION COEFFICIENT OF THE J-TH ION
C-----------------------------------------------------------------------
	CALL ZASTUP(DM,TEMP,EKONC,ZIP,STAVS,RR,RION,R1,NDIM,NBOD
     P  ,NION1,NION)
C-----------------------------------------------------------------------
C		RHYD -CALCULATED H RADIUS, IN AGREEMENT WITH 
C		VALENCE S ORBITAL RADIUS
C		POLARH - HYDROGEN POLARIZABILITY
        RHYD=5.3D-9	
	POLARH=0.666793D-24  
        DO 380 I=1,NBOD
        DO 320 K=1,NION
          HII=AKONC(I)*ABHYD-HI(I)
          IF (K.EQ.1)THEN
C		PDNN - NEUTRAL COLLIDING WITH NEUTRAL HYDROGEN
C		PDNI - NEUTRAL COLLIDING WITH ION (PROTONS)
	    PDNN=DHS(HMC,TEMP(I),RHYD,RATOM,HI(I))
	    PDNI1=DHS(HMC,TEMP(I),0.D0,RATOM,HII)
	    PDNI2=DNI(HMC,TEMP(I),POLAR,HII)
	    IF(PDNI1.LT.PDNI2)THEN
              PDNI=PDNI1
	    ELSE
              PDNI=PDNI2
	    ENDIF
            DI(I,K)=1.D0/(1.D0/PDNN+1.D0/PDNI)
            GO TO 320
	  ELSE
C               PDIN - ION COLLIDING WITH NEUTRAL HYDROGEN
C               PDII - ION COLLIDING WITH ION (PROTONS)
	    ZIK=DBLE(K)   
	    PDIN=DNI(HMC,TEMP(I),POLARH,HI(I))
	    PDII=DII(HMC,TEMP(I),EKONC(I),ZIK,HII)
	    DI(I,K)=1.D0/(1.D0/PDIN+1.D0/PDII)
          ENDIF
320     CONTINUE
380     CONTINUE
    	WRITE(2,*)' DIFFUSION COEFFICIENTS'
        WRITE(2,'(A,40I11)')' TEMP',(I,I=1,NION)
        DO 390 I=1,NBOD
          WRITE (2,400)TEMP(I),(DI(I,K),K=1,NION)
390     CONTINUE
    	WRITE(2,*)' TPG TERMS'
        WRITE(2,'(A,40I11)')' TEMP',(I,I=1,NION)
        DO 395 I=1,NBOD
          WRITE (2,400)TEMP(I),(TPG(I,K),K=1,NION)
395     CONTINUE 
400	FORMAT (F7.0,40E11.3)
C-----------------------------------------------------------------------
C	WEIGHTING OF ION RADIATIVE ACCELERATIONS AND TOTAL ELEMENT
C	RADIATIVE ACCELERATION
C        WRITE(6,'(A,$)')' WEIGHTING BY DIFF.COEF [1-YES,0-NO]   => '
C        READ(5,*)IVOL
C	ASSUMES NO INTERPOLATION AND
C	READS RAD. ACCEL GRADN(I,J,K) FOR I=2,NBOD-1; J=1,NION;
C	                                         AND   K=1,NABUND 
	IVOL=1
	INF=10
        OPEN(INF,FILE='accel.sum',STATUS='UNKNOWN')
        CALL RAD(INRAD,NDIM,NBOD,NION1,NION,NAB1,NABUND,ABUND,DM
     P  ,DI,RR,GRADN,WGRADN,POM,IVOL,INF)
	CLOSE(INF)
	IVOL=0
	INF=11
        OPEN(INF,FILE='accel.sum2',STATUS='UNKNOWN')
        CALL RAD(INRAD,NDIM,NBOD,NION1,NION,NAB1,NABUND,ABUND,DM
     P  ,DI,RR,GRADN,WGRADN,POM,IVOL,INF)
	CLOSE(INF)
C               INTEPOLATION OF GRADN TO A REFERENCE HOMOGENEOUS 
C	ABUNDANCE AND 
C	CALCULATION OF LOGARITHMIC GRADIENT OF ION ABUNDANCES -GRR
        IF (NABUND.EQ.1)THEN
          IF (DABS(ABP-ABUND(1)).GT.1.D-30)GOTO 1200
        ENDIF
        DO 750 J=1,NION
          DO 740 I=2,NBOD-1
            CALL ACCINT(GRADN,ABUND,ABP,J,I,GRAD0(I,J),POM2,POM3
     P      ,NABUND,NDIM1,NION1,NAB1)
            GRR(I,J)=BLB(DLOG(RR(I-1,J)),HLB(I-1),DLOG(RR(I,J)),
     P      HLB(I),DLOG(RR(I+1,J)),HLB(I+1))
740       CONTINUE
750     CONTINUE  
C-----------------------------------------------------------------------
C               DIFFUSION VELOCITIES AND FLUX OF IONS WITH THE DEPTH
C               UNDER THE ASSUMPTION OF ELEMENT ABUNDANCE GRADIENT= 0,
C               I.E. HOMOGENEOUS (E.G. SOLAR) ABUNDANCE
C		BUT ION ABUNDANCE GRADIENTS <> 0.
        DO 790 J=1,NION
          DO 760 I=2,NBOD-1 
            VI(I,J)=VDI(TPG(I,J),GRR(I,J),GRAD0(I,J)
     P      ,DI(I,J),VT(I),HMC,TEMP(I))
            TOK(I,J)=VI(I,J)*RR(I,J)*AKONC(I)*ABP
C	    WRITE(12,'(2i3,2e10.3)')i,j,GRR(I,J),TOK(I,J)
760       CONTINUE
790     CONTINUE
800     FORMAT (40E11.3)
        WRITE(2,*)' DIFFUSION VELOCITIES'
        WRITE(2,'(A,40I11)')' DM ',(I,I=1,NION)
        DO 810 I=2,NBOD-1 
          WRITE(2,800)DM(I),(VI(I,J),J=1,NION)
810     CONTINUE
        WRITE(2,*)' ION PARTICLE FLUXES'
        WRITE(2,'(A,40I11)')' DM ',(I,I=1,NION)
        DO 820 I=2,NBOD-1 
          WRITE(2,800)DM(I),(TOK(I,J),J=1,NION)
820     CONTINUE
	CLOSE(2)
C-----------------------------------------------------------------------
        GO TO 1220
1200    WRITE (6,1210)
1210    FORMAT (' ERROR IN THE DIF CODE')
1220    CONTINUE
        STOP
        END
C-----------------------------------------------------------------------
        FUNCTION HLAV1(F1,F2,F3,DF1,DF2,DF3,DI1,DI2,DI3,TP1,TP2,TP3,VT)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        HLAV1=((DI1+VT)*DF1+(DI2+VT)*DF2+(DI3+VT)*DF3
     P  -F1*DI1*TP1-F2*DI2*TP2-F3*DI3*TP3)
     P  /((DI1+VT)*F1+(DI2+VT)*F2+(DI3+VT)*F3)
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION HLAV2(F1,F2,F3,DI1,DI2,DI3,TK,AK,VT)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        HLAV2=TK/AK/((DI1+VT)*F1+(DI2+VT)*F2+(DI3+VT)*F3)
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION HLAV3(C,F1,F2,F3,DI1,DI2,DI3,GR1,GR2,GR3,VT)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        HLAV3=C*(DI1*F1*GR1+DI2*F2*GR2+DI3*F3*GR3)
     P  /((DI1+VT)*F1+(DI2+VT)*F2+(DI3+VT)*F3)
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE ACCINT(GRADN,ABUND,ABP,JTY,ITY,GR,POM2,POM3,NABUND
     P  ,NDIM1,NION1,NAB1)
C	INTERPOLATES IN THE RADIATIVE ACCELERATIONS -GRADN
C	CALCULATED FOR ABUNDANCES -ABUND TO THE ABUNDANCE NECESSARY -ABP
C		K-ABUNDANCES
C               J-IONS
C               I-DEPTH
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DIMENSION GRADN(NDIM1,NION1,NAB1),ABUND(NAB1),POM2(NAB1)
     P  ,POM3(NAB1)
        IF (NABUND.EQ.1)THEN
          GR=GRADN(ITY,JTY,1)
          RETURN
        ELSE
          DO 760 K=1,NABUND
C            POM2(K)=DLOG10(GRADN(ITY,JTY,K))
C		RAD. ACCELERATION MAY BE NEGATIVE SO:
            POM2(K)=GRADN(ITY,JTY,K)
	    POM3(K)=DLOG10(ABUND(K))
760       CONTINUE
          CALL INTEP(DLOG10(ABP),GR,POM3,POM2,NABUND,IER)
C          CALL INTEP(ABP,GR,ABUND,POM2,NABUND,IER)
C 	   GR=10**GR
        ENDIF
        RETURN
        END
C-----------------------------------------------------------------------
C       SUBROUTINE   I N T E P  : SPLINE INTERPOLATION SCHEME BASED
C                                 ON HERMITE POLYNOMIALS
C        INPUT : XP  - THE CHOSEN ARGUMENT VALUE
C                X   - THE VECTOR OF INDEPENDENT VALUES
C                F   - THE VECTOR OF FUNCTION OR DEPENDENT VALUES
C                N   - THE NUMBER OF POINTS IN THE (X,F) VECTORS
C       OUTPUT : P   - THE RESULTANT INTERPOLATED VALUE
C                IER - THE RESULTANT ERROR PARAMETER
        SUBROUTINE INTEP(XP,P,X,F,N,IER)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        REAL LP1,LP2,L1,L2
        DIMENSION F(N),X(N)
        IER=1
        IO=1
        IUP=0
        IF(X(2).LT.X(1)) IUP=1
        N1=N-1
        IF((XP.GE.X(N).AND.IUP.EQ.0).OR.(XP.LE.X(N).AND.IUP.EQ.1)) THEN
         P=F(N)
         IER=2
         RETURN
        ELSE IF((XP.LE.X(1).AND.IUP.EQ.0).OR.
     *   (XP.GE.X(1).AND.IUP.EQ.1)) THEN
         P=F(1)
         IER=2
         RETURN
        END IF
        DO 1 I=IO,N
         IF(XP.LT.X(I).AND.IUP.EQ.0) GOTO 2
         IF(XP.GT.X(I).AND.IUP.EQ.1) GOTO 2
1       CONTINUE
        P=F(N)
        IER=2
        RETURN
2       I=I-1
        IF(I.EQ.IO-1) GOTO 4
        IO=I+1
        LP1=1./(X(I)-X(I+1))
        LP2=1./(X(I+1)-X(I))
        IF(I.EQ.1) FP1=(F(2)-F(1))/(X(2)-X(1))
        IF(I.EQ.1) GOTO 3
        FP1=(F(I+1)-F(I-1))/(X(I+1)-X(I-1))
3       IF(I.GE.N1) FP2=(F(N)-F(N-1))/(X(N)-X(N-1))
        IF(I.GE.N1) GOTO 4
        FP2=(F(I+2)-F(I))/(X(I+2)-X(I))
4       XPI1=XP-X(I+1)
        XPI=XP-X(I)
        L1=XPI1*LP1
        L2=XPI*LP2
        P=F(I)*(1.-2.*LP1*XPI)*L1*L1+F(I+1)*(1.-2.*LP2*XPI1)
     *  *L2*L2+FP2*XPI1*L2*L2+FP1*XPI*L1*L1
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION BLB(X,XH,Y,YH,Z,ZH)
C             CALCULATES A GRADIENT OF A FUNCTION TAKING INTO ACCOUNT
C	SECOND ORDER TERMS OF THE TAYLER EXPANSION.
C             WE ASSUME :  HX<YH<ZH
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        BLB=((YH-XH)*(YH-XH)*Z-((YH-XH)*(YH-XH)
     P  -(ZH-YH)*(ZH-YH))*Y-(ZH-YH)*(ZH-YH)*X)/((ZH-XH)*(ZH-YH)*(YH-XH))
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION BLB1(X,XH,Y,YH,Z,ZH)
C             GRADIENT OF A FUNCTION AT THE BEGINNING BOUNDARY
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        BLB1=(((YH-XH)*(YH-XH)-(ZH-XH)*(ZH-XH))*X
     P  +(ZH-XH)*(ZH-XH)*Y-(YH-XH)*(YH-XH)*Z)/((ZH-XH)*(YH-XH)*(ZH-YH))
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION BLB2(X,XH,Y,YH,Z,ZH)
C             GRADIENT OF A FUNCTION AT THE END BOUNDARY
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        BLB2=(((ZH-XH)*(ZH-XH)-(ZH-YH)*(ZH-YH))*Z
     P  -(ZH-XH)*(ZH-XH)*Y+(ZH-YH)*(ZH-YH)*X)/((ZH-XH)*(YH-XH)*(ZH-YH))
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION DII(HMC,TE,EKONC,Z,HII)
C             DIFF. COEF. ION DIFFUSING AMONG PROTONS
C               HMC-ATOMIC MASS NUMBER
C               TE-TEMPERATURE
C		EKONC- ELECTRON NUMBER DENSITY
C		Z - EFFECTIVE ION CHARGE (1-NEUTRAL,...)
C               HII- PROTON NUMBER DENSITY
C	CGS-UNITS
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	A12=DLOG(1.D0+2.732D8*TE**3./((Z-1.D0)*(Z-1.D0)*EKONC))
	BOTTOM=HII*(Z-1.D0)*(Z-1.D0)*A12
        DII=1.947D9*TE**2.5*(1.D0+HMC)/HMC/BOTTOM
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION DHS(HMC,TE,RH,RAT,HI)
C	DIFF. COEF. FOR NEUTRAL ATOM DIFFUSING IN NEUTRAL HYDROGEN
C       HARD-SPHERE APPROXIMATION (VAUCLAIR S., 1983, ASTROPHYS.
C	PROCESSES IN UPPER MAIN SEQUENCE STARS, EDS. HAUCK B., MAEDER A.
C	,SAUVERNY,GENEVA OBS.,P.167 
C               HMC-ATOMIC MASS NUMBER
C               TE-TEMPERATURE
C               RH-NEUTRAL HYDROGEN ATOM RADIUS
C               RAT-NEUTRAL ELEMENT ATOM RADIUS
C               HI-NEUTRAL HYDGROGEN NUMBER DENSITY
C	CGS-UNITS
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	POM=TE*1.D-4*(HMC+1.D0)/HMC
	POM2=(RH+RAT)*(RH+RAT)*4.D0*1.D16
        DHS=5.44D21*DSQRT(POM)/HI/POM2
        RETURN
        END
C-----------------------------------------------------------------------
C        FUNCTION DHS(HMC,RH,RAT,TE,HI)
C               DIFF. COEF. FOR NEUTRAL ATOM DIFFUSING IN NEUTRAL
C       HYDROGEN (OUR HARD-SPHERE APPROXIMATION)
C	CHECK IT AS IT GIVES APPROX HMC TIMES SMALLER RESULT??
C	D=MU*K*T=TAU*K*T/M    WHERE 1/TAU IS COLLISION FREQUENCY
C               HMC-ATOMIC MASS NUMBER
C		RH-NEUTRAL HYDROGEN ATOM RADIUS
C		RAT-NEUTRAL ELEMENT ATOM RADIUS
C               TE-TEMPERATURE
C               HI-NEUTRAL HYDGROGEN NUMBER DENSITY 
C
C        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C        DHS=1.38062D-16*TE/(HMC*1.66053D-24)
C     P  /(3.14159D0*(RH+RAT)*(RH+RAT)*HI*DSQRT(3.D0*1.38062D-16
C     P  *TE*(1.+HMC)/(HMC*1.66053D-24)))
C        RETURN
C        END   
C-----------------------------------------------------------------------
        FUNCTION DNI(HMC,TE,ALF,HII)
C             DIF.COEF. FOR NEUTRAL ATOM DIFFUSING IN A GASS OF PROTONS
C             (POLARIZATION EFFECT)
C               HMC-ATOMIC MASS NUMBER
C		TE-TEMPERATURE
C               HII-PROTON NUMBER DENSITY
C               ALF-POLARIZABILITY [CM^3]
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	POM=(1.D0+HMC)/HMC/ALF
        DNI=3.3D4*TE*DSQRT(POM)/HII
        RETURN
        END
C-----------------------------------------------------------------------
        FUNCTION VDI(TPGJ,GPAAJ,GRADJ,DIJ,DT1,HMC,TEMP)
C             DIFFUSION VELOCITY POSITIVE DOWNWARD (TPGJ,GRADJ>0)
C	DT1-TURBULENT DIFFUSION COEFFICIENT (NOT VELOCITY??)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        BOL=1.3806503D-16
        HJED=1.66053873D-24
	GRAD=GRADJ*HMC*HJED/(BOL*TEMP)
        VDI=DIJ*(-(1.D0+DT1/DIJ)*GPAAJ+TPGJ-GRAD)
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE HMODEL(INMOD,NDIM1,NDPTH,TEFF,GLOG
     P  ,DEPTH,HLB,TEMP,PRESS,ELEC,AKONC,DENS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION DEPTH(NDIM1),HLB(NDIM1),TEMP(NDIM1),PRESS(NDIM1),
     P  ELEC(NDIM1),AKONC(NDIM1),DENS(NDIM1),X(500)   
        CHARACTER*30 INMOD
C
C             MODEL OF THE ATMOSPHERE (HUBENY)
C
C       DEPTH - MASS DEPTH COORDINATE 
C       TEMP - TEMPERATURE
C       ELEC - ELECTRON NUMBER DENSITY [CGS]
C       AKONC - (ALL) ATOM NUMBER DENSITY [CGS]
C       DENS - DENSITY [CGS]
C       HLB - GEOMETRICAL DEPTH
C	PRESS - PRESSURE
C
C       ??      WMM=SUM_e (M_e*ABUNDANCE_e)  IS THE MEAN ATOM MASS
C       WHERE ABUNDANCE_e IS N_e/AKONC
C       FOR 90% H + 10 % HE  :
        WMM=2.2034D-24
        BOL=1.38062D-16
        OPEN(3,FILE=INMOD,STATUS='OLD')
        READ(3,*) NDPTH,NUMPAR
        READ(3,*) (DEPTH(I),I=1,NDPTH)
        HLB(1)=0.D0	
        DO 30 ID=1,NDPTH
          READ(3,*) (X(I),I=1,NUMPAR)
          TEMP(ID)=X(1)
          ELEC(ID)=X(2)
          DENS(ID)=X(3)
          AKONC(ID)=DENS(ID)/WMM
	  PRESS(ID)=(AKONC(ID)+ELEC(ID))*BOL*TEMP(ID)
          IF(ID.GT.1) THEN
            DELTA=2.D0*(DEPTH(ID)-DEPTH(ID-1))/(DENS(ID)+DENS(ID-1))
            HLB(ID)=DELTA+HLB(ID-1)
          ENDIF
C          write(9,'(4e11.4)')depth(id),temp(id),elec(id),dens(id)
30      CONTINUE
        TEFF=0.D0
        GLOG=0.D0
        CLOSE(3)
        RETURN  
        END     
C-----------------------------------------------------------------------
        SUBROUTINE SSMODEL(INMOD,NDIM1,NDPTH,TEFF,GLOG
     P  ,DEPTH,HLB,TEMP,PRESS,ELEC,AKONC,DENS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION DEPTH(NDIM1),HLB(NDIM1),TEMP(NDIM1),PRESS(NDIM1),
     P  ELEC(NDIM1),AKONC(NDIM1),DENS(NDIM1)
        CHARACTER*30 INMOD
C
C             STELLAR STRUCTURE MODEL (J. FERNANDES)
C
C       DEPTH - MASS DEPTH COORDINATE LN(M_R/M) 
C       TEMP - TEMPERATURE
C       ELEC - ELECTRON NUMBER DENSITY [CGS]
C       AKONC - (ALL) ATOM NUMBER DENSITY [CGS]
C       DENS - DENSITY [CGS]
C       HLB - RADIUS
C	PRESS - PRESSURE
C
C	HYDROGEN AND HELIUM ABUNDANCES CHANGE WITH DEPTH
C               WMM=SUM_e (M_e*ABUNDANCE_e)  IS THE MEAN ATOM MASS
C       WHERE ABUNDANCE_e IS N_e/AKONC
C       FOR 90% H + 10 % HE  :
        WMM=2.2034D-24
        BOL=1.38062D-16
	RGASS=8.314472D7
	AVOG=6.02214199D23
        OPEN(3,FILE=INMOD,STATUS='OLD')
        READ(3,'(/////,I10)') NDPTH
        READ(3,*)EMTOT,ERTOT,ELTOT
	WRITE(9,*)'# EMTOT,ERTOT,ELTOT ',EMTOT,ERTOT,ELTOT
 	write(9,*)'# hlb,     ln m/M,     temp,      press,     dens,   
     p      emol,      elec,     akonc'
        READ(3,'(/)')
        DO 30 ID=1,NDPTH
          READ(3,*)HLB(ID),DEPTH(ID),TEMP(ID),PRESS(ID),DENS(ID)
 	  READ(3,*)
 	  READ(3,*)POM1,POM2,POM3,EMOL
C	   EMOL IS NO.OF ELECTRONS IN 1 MOLE OF GASS/AVOGADRO CONSTANT
          ELEC(ID)=PRESS(ID)/TEMP(ID)/RGASS*EMOL*AVOG
 	  READ(3,'(//)')
C	  ?? NEXT LINE IS VALID ONLY IF GASS PRESSURE=TOTAL PRESSURE
C	  AND STATE EQUATION HOLDS
          AKONC(ID)=PRESS(ID)/BOL/TEMP(ID)-ELEC(ID)
          write(9,'(8e11.4)')hlb(id),depth(id),temp(id),press(id),
     p     dens(id),emol,elec(id),akonc(id)
30      CONTINUE
        TEFF=0.D0
        GLOG=0.D0
        CLOSE(3)
        RETURN  
        END     
C-----------------------------------------------------------------------
        SUBROUTINE AMODEL(INMOD,NDIM1,ND0,TEFF,GLOG
     P  ,DM,HLB,TEMP,PRESS,EKONC,ABROSS,AKONC,DENS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION DM(NDIM1),TEMP(NDIM1),PRESS(NDIM1),EKONC(NDIM1)
     P  ,ABROSS(NDIM1),AKONC(NDIM1),DENS(NDIM1),HLB(NDIM1)             
        CHARACTER*30 INMOD
C
C             MODEL OF THE ATMOSPHERE (NEW KURUCZ)
C
C       DM - MASS DEPTH COORDINATE
C       HLB - GEOMETRICAL DEPTH
C       TEMP - TEMPERATURE
C       PRESS - GASS PRESSURE
C       EKONC - ELECTRON NUMBER DENSITY
C       ABROSS - ROSSELAND MEAN OPACITY [CM^2/G]
C       AKONC - (ALL) ATOM NUMBER DENSITY
C       DENS - DENSITY
C
        OPEN(3,FILE=INMOD,STATUS='OLD')
        READ(3,30) TEFF,GLOG
        READ(3,35) ND0
30      FORMAT(4X,F8.0,9X,F8.5)
35      FORMAT(/////////////////////10X,I3)
        BOL=1.38062D-16
C               WMM=SUM_e (M_e*ABUNDANCE_e)  IS THE MEAN ATOM MASS
C       WHERE ABUNDANCE_e IS N_e/AKONC
C       FOR 90% H + 10 % HE  :   
        WMM=2.2034D-24
        HLB(1)=0.D0   
        DO 40 I=1,ND0 
          READ(3,*)DM(I),TEMP(I),PRESS(I),EKONC(I),ABROSS(I)
          AKONC(I)=PRESS(I)/TEMP(I)/BOL
          AKONC(I)=AKONC(I)-EKONC(I)   
          DENS(I)=AKONC(I)*WMM
          IF(I.GT.1) THEN
            DELTA=2.D0*(DM(I)-DM(I-1))/(DENS(I)+DENS(I-1))
            HLB(I)=DELTA+HLB(I-1)
          ENDIF
40      CONTINUE
        CLOSE(3)
        RETURN  
        END    
C-----------------------------------------------------------------------
	SUBROUTINE AINTEP(NMOD,NBOD,INTERP,DM,VDM,HLB,VHLB,TEMP,VTEMP
     P  ,PRESS,VPRESS,AKONC,VAKONC,EKONC,VEKONC,DENS,VDENS,VT,VVT)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION HLB(NMOD),DM(NMOD),EKONC(NMOD),AKONC(NMOD),PRESS(NMOD)
     P  ,TEMP(NMOD),DENS(NMOD),VT(NMOD)
     P  ,VHLB(NBOD),VDENS(NBOD),VAKONC(NBOD),VEKONC(NBOD)
     P  ,VPRESS(NBOD),VTEMP(NBOD),VDM(NBOD),VVT(NBOD)
        DO 70 I=1,NMOD-1
         DO 60 J=1,INTERP
	  IPOINT=(I-1)*(INTERP+1)+J+1
          DM(IPOINT)=(VDM(I+1)-VDM(I))/FLOAT(INTERP+1)
     P     *FLOAT(J)+VDM(I)
          CALL INTEP(DM(IPOINT),PRESS(IPOINT)
     P     ,VDM,VPRESS,NMOD,IER)
          CALL INTEP(DM(IPOINT),AKONC(IPOINT)
     P     ,VDM,VAKONC,NMOD,IER)
          CALL INTEP(DM(IPOINT),EKONC(IPOINT)
     P     ,VDM,VEKONC,NMOD,IER)
          CALL INTEP(DM(IPOINT),TEMP(IPOINT)
     P     ,VDM,VTEMP,NMOD,IER)
          CALL INTEP(DM(IPOINT),HLB(IPOINT)
     P     ,VDM,VHLB,NMOD,IER)
          CALL INTEP(DM(IPOINT),VT(IPOINT)
     P     ,VDM,VVT,NMOD,IER)
          CALL INTEP(DM(IPOINT),DENS(IPOINT)
     P     ,VDM,VDENS,NMOD,IER)
C	write(6,*)'interp,j',interp,j 
60       CONTINUE
	 IPO=(I-1)*(INTERP+1)+1
         PRESS(IPO)=VPRESS(I)
         AKONC(IPO)=VAKONC(I)
         EKONC(IPO)=VEKONC(I)
         HLB(IPO)=VHLB(I)
         TEMP(IPO)=VTEMP(I)
         DM(IPO)=VDM(I)
         VT(IPO)=VVT(I)
         DENS(IPO)=VDENS(I)
70     CONTINUE
       IPON=NMOD+INTERP*(NMOD-1)
       HLB(IPON)=VHLB(NMOD)
       PRESS(IPON)=VPRESS(NMOD)
       AKONC(IPON)=VAKONC(NMOD)
       EKONC(IPON)=VEKONC(NMOD)
       TEMP(IPON)=VTEMP(NMOD)
       DM(IPON)=VDM(NMOD)
       VT(IPON)=VVT(NMOD)
       DENS(IPON)=VDENS(NMOD)
        RETURN  
        END    
C-----------------------------------------------------------------------
        SUBROUTINE PFIRW(NDIM,NBOD,NION1,NION,STA,TEMP,STAVS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C       PARAMETER(NION1=9)
        DIMENSION STA(6,NION1),STAVS(NDIM,NION1),TEMP(NDIM)
        DO 80 I=1,NBOD
          DO 70 J=1,NION
            IF (ABS(STA(1,J)-0.D0).LT.1.D-30) GO TO 60
            SALA=DLOG(TEMP(I))
            ARG=STA(1,J)+STA(2,J)*SALA+STA(3,J)*SALA*SALA+
     P      STA(4,J)*SALA**3.D0+STA(5,J)*SALA**4.D0+STA(6,J)*SALA**5.D0
            STAVS(I,J)=DEXP(ARG)
            GO TO 70
60          STAVS(I,J)=1.D0
70        CONTINUE
80      CONTINUE
	WRITE (2,'(A)')' PARTITION FUNCTIONS'
	WRITE (2,'(A,20I10)')' TEMP',(I,I=1,NION)
        DO 140 I=1,NBOD
          WRITE(2,130)TEMP(I),(STAVS(I,J),J=1,NION)
130       FORMAT(F7.0,20E10.3)
140     CONTINUE
        RETURN
        END
C-----------------------------------------------------------------------
        subroutine potlow(TEMP,ane,eplow)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c       TEMP - Temperature[K]
c       ane - electron number density [cm^{-3}]
c       lowering of the ionization potential for neutrals, z=1 in [eV]
c       for ions(z):      eplow(z)=z*eplow(1)
        BOL=1.38062D-16
        PI=3.14159D0
        e=4.80325d-10
        pom=bol*TEMP/8.d0/pi/ane
c       debye lenght in [CGS]
        debye=sqrt(pom)/e
        eplow=1.44d-7/debye
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE PFDWOR(NDIM,NBOD,NION1,NION,IAT,TEMP,EKONC,STAVS)
c
c       partition functions after:
c       M.M.Dworetsky & B. Smalley, private communication
c
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION STAVS(NDIM,NION1),EKONC(NDIM),TEMP(NDIM),U(5)
        DO 80 I=1,NBOD
          CALL POTLOW(TEMP(I),EKONC(I),EPLOW)
          THETA=5039.77D0/TEMP(I)
C               PARTFN IS IN 'pfdwor.inc'
          CALL PARTFN(IAT,THETA,U,EPLOW)
          DO 70 J=1,NION
            IF(J.LE.5)THEN
              STAVS(I,J)=U(J)
            ELSE
              STAVS(I,J)=1.D0
            ENDIF
70        CONTINUE
80      CONTINUE
	WRITE (2,'(A)')' PARTITION FUNCTIONS'
	WRITE (2,'(A,20I10)')' TEMP',(I,I=1,NION)
        DO 140 I=1,NBOD
          WRITE(2,130)TEMP(I),(STAVS(I,J),J=1,NION)
130       FORMAT(F7.0,20E10.3)
140     CONTINUE
        RETURN
        END
C-----------------------------------------------------------------------
        DOUBLE PRECISION FUNCTION SAH(TE,EK,ZP,S1,S2)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C             SAHA EQUATION (RATIO OF THE TWO NEIGHBOUR ION NUMBER
C       DENSITIES)
C             ZP -IV [EV],BOLT.CONST.-IN [ERG/K]
        BOL=1.3806503D-16
        SAH=1.2020D9*S2/(S1*(5039.77D0/TE)**2.5D0
     P  *DEXP(2.302585D0*5039.77D0/TE*ZP)*EK*TE*BOL)
        RETURN   
        END      
C-----------------------------------------------------------------------
        SUBROUTINE RAD(INRAD,NDIM,NBOD,NION1,NION,NAB1,NABUND,ABUND,DM
     P  ,DI,RR,GRADN,WGRADN,POM,IVOL,INF)
C	?? WORKS ONLY IF THERE WAS NO INTERPOLATION AS GRADN
C	IS NOT INTERPOLATED HERE ... AND WITH HUBENY'S MODELS
C	INF=OUTPUT UNIT
C	IVOL=KIND OF WEIGHTING
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        CHARACTER*30 INRAD
        DIMENSION DI(NDIM,NION1),RR(NDIM,NION1),DM(NDIM),ABUND(NAB1)
     P  ,GRADN(NDIM,NION1,NAB1),WGRADN(NAB1),POM(NION1)
C        WRITE(6,'(10X,A)')' ACCELERATION IS READ FROM THE BOTTOM'
C        WRITE(6,'(A,$)')' INPUT FILE WITH RAD. ACCELERATION   => '
C        READ(5,'(A30)')INRAD
	INRAD='accel.tot'
C        WRITE(6,'(A,$)')' WEIGHTING BY DIFF.COEF [1-YES,0-NO]   => '
C        READ(5,*)IVOL
        OPEN(99,FILE=INRAD,STATUS='OLD')
        WRITE(INF,125)0.,0.,0.
        WRITE(INF,640)0.
        WRITE(INF,645)(ABUND(IA),IA=1,NABUND)
        WRITE(INF,650)0.
125     FORMAT('# TEFF, LOGG, ELEMENT :',F10.0,F10.2,I10) 
640     FORMAT('# NO. LINES :',200I10) 
645     FORMAT('# ABUNDANCE :',200E10.3)  
650     FORMAT('# ION       :',200I10)
	IF(IVOL.EQ.1)THEN
	  WRITE(INF,'(A)')'##   DM   RAD=(SUMi Di*Ni*Ai)/(SUMi Di*Ni)'
	ELSE
	  WRITE(INF,'(A)')'##   DM   RAD=(SUMi Ni*Ai)/(SUMi Ni)'
	ENDIF
	READ(99,'(////)')
        DO 50 I=NBOD-1,2,-1
          READ(99,*)IZMAZ,ZMAZ,((GRADN(I,J,K),J=1,NION),K=1,NABUND)
C          WRITE(INF,'(30E11.3)')((GRADN(I,J,K),J=1,NION),K=1,NABUND)
	  SUMPOM=0.
	  DO 10 M=1,NION 
            IF(IVOL.EQ.1) THEN
	     POM(M)=RR(I,M)*DI(I,M)
	    ELSE
	      POM(M)=RR(I,M)
	    ENDIF
	    SUMPOM=SUMPOM+POM(M)
10        CONTINUE
	  DO 40 L=1,NABUND
            WGRADN(L)=0.
	    DO 20 M=1,NION 
              WGRADN(L)=POM(M)*GRADN(I,M,L)+WGRADN(L)
20          CONTINUE
            WGRADN(L)=WGRADN(L)/SUMPOM
40        CONTINUE
          WRITE(INF,30)ZMAZ,(WGRADN(L),L=1,NABUND)
30 	  FORMAT(3X,20E10.3)
50      CONTINUE
        CLOSE (99)
        RETURN
        END
C-----------------------------------------------------------------------
	SUBROUTINE ZASTUP(DM,TEMP,EKONC,ZIP,STAVS,RR,RION,R1,NDIM,NBOD
     P  ,NION1,NION)
C       RR(I,J)- POPULATION OF THE J-TH ION/TOTAL ELEMENT POLULATION
C		 AT I-TH DEPTH
C	R1(J)= N(J)/N(1)
C	RION(J)= N(J)/N(J-1)
C
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DIMENSION ZIP(NION1-1),STAVS(NDIM,NION1)
     P  ,DM(NDIM),TEMP(NDIM),EKONC(NDIM)
     P  ,RION(NION1),R1(NION1),RR(NDIM,NION1)
	DO 10 J=1,NION1
	  DO 5 I=1,NBOD
	    RR(I,J)=1.D-31
5	  CONTINUE
10	CONTINUE
        DO 40 I=1,NBOD
	  RION(1)=1
	  R1(1)=1
	  SUM1=1.D0
	  DO 20 J=2,NION
	    RION(J)=SAH(TEMP(I),EKONC(I),ZIP(J-1),STAVS(I,J-1)
     P      ,STAVS(I,J))
            R1(J)=R1(J-1)*RION(J)
	    SUM1=SUM1+R1(J)
20	  CONTINUE
	  DO 30 J=1,NION
	    RR(I,J)=R1(J)/SUM1
30	  CONTINUE
40	CONTINUE
         WRITE(2,*)'   N(J)/N  ION POPULATIONS'
         WRITE(2,'(A,40I11)')' DM',(I,I=1,NION)
	DO 50 I=1,NBOD
	  WRITE(2,130)DM(I),(RR(I,J),J=1,NION)
130	  FORMAT(40(D10.3,1X))
50	CONTINUE
	RETURN
	END
C-----------------------------------------------------------------------
        INCLUDE 'pfdwor.inc'
