C
C	PROGRAM MAKEINPUT
C
C	TO MAKE INPUT FILE FOR SYNSPEC42:    'LAMBDA','ABUNDANCES'
C	AND INPUT FOR ACCEL:	'NO.LINE','LINE.DAT'
C	IT CALCULATES STEP AND INTERVAL FOR THE SPECTRUM SYNTHESIS
C
C       INPUT:
C		linelist - LIST OF LINES OF THE ELEMENT OF INTERREST
C               no.line - IDENTIFIER (ORDER) OF THE CURRENT LINE 
C	 		IN THE LINELIST AND ORDER OF CURRENT ABUNDANCE
C		lambda0 - EXAMPLE OF THE SYNSPEC INPUT FILE (*.55)
C		abundances0 -EXAMPLE OF THE SYNSPEC INPUT FILE (*.56)
C		element.dat  - ATOMIC DATA FOR THE CHEM.ELEMENT
C               model - NEW KURUZC ATMOSPHERE MODEL
C		model.hub - HUBENY ATMOSPHERE MODEL
C		hladaj.in - ION, T_1,T_2
C
C       OUTPUT:
C		lambda - MODIFIED SYNSPEC INPUT FOR THE CURRENT LINE
C		abundances - MODIFIED SYNSPEC INPUT FOR THE CURRENT LINE
C		no.line - NEW IDENTIFIER OF THE NEXT LINE AND ABUNDANCE
C		line.dat - DATA FOR THE CURRENT LINE
C		spectrum.20 - SUBSIDIARY DUMMY ERROR FILE
C		makeinput.out - MORE DETAIL OUTPUT
C
C	COMMENT: CGS UNITS, NBOD - NO. OF KURUCZ MODEL DEPTH POINTS
C		?? - MEANS POSSIBLE PROBLEM
C	
	PARAMETER (NDIM=100,NION1=9,NAB1=10)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION HIS(2),HEIS(3),ZIP(NION1-1),HI(NDIM),HEI(NDIM)
     P  ,CTEP(NION1,3),IKDM(NION1,3),IHDM(NION1,3),STAHI(6,2)
     P  ,STAHEI(6,3),STA(6,NION1),STAVS(NDIM,NION1)
     P  ,ABUND(NAB1),DMHLB(NDIM),EKONC(NDIM),AKONC(NDIM),TEMP(NDIM)
     P  ,HLB(NDIM),TLAK(NDIM),DENS(NDIM),ABROSS(NDIM) 
     P  ,HDMHLB(NDIM),HTEMP(NDIM),HEKONC(NDIM),HAKONC(NDIM),HDENS(NDIM)
     P  ,RION(NION1),R1(NION1),RR(NDIM,NION1)
C     P  ,ZI(NDIM,3),SA(NDIM,2),F1T(NDIM,3),STAV(NDIM,NION1)
C        SAH(TE,EK,ZP,S1,S2)=1.2020D9*S2/(S1*(5039.77D0/TE)**2.5D0
C     P  *DEXP(2.302585D0*5039.77D0/TE*ZP)*EK*TE*1.38062D-16)
	CHARACTER*100 A100
	CHARACTER*30 INN
C------------------------------------------------------------------
        WRITE(6,'(A)')' MAKEINPUT'
C        WRITE(6,'(A)')' INPUT: '
C        WRITE(6,'(A)')' linelist - (8) DATA FOR THE SPECTRAL LINES'
C	WRITE(6,'(A,A)')' no.line - (9) IDENTIFIERS OF THE CURRENT LINE'
C     P  ,' IN THE LINELIST AND THE CURRENT ABUNDANCE'
C        WRITE(6,'(A)')' line.dat - (8) DATA FOR THE CURRENT LINE'
C	WRITE(6,'(A)')' lambda0 - (2) EXAMPLE OF SYNSPEC INPUT'
C        WRITE(6,'(A)')' abundances0 - (2) EXAMPLE OF SYNSPEC INPUT' 
C        WRITE(6,'(A)')' element.dat  - (7) ATOMIC DATA FOR THE ELEMENT'
C        WRITE(6,'(A)')' model - (3) NEW KURUZC ATMOSPHERE MODEL'
C	WRITE(6,'(A)')' model.hub - (3) HUBENY ATMOSPHERE MODEL'
C	WRITE(6,'(A)')' hladaj.in - (11) ION, T_1,T_2'
C        WRITE(6,'(A)')' OUTPUT: '
C	WRITE(6,'(A,A)')' lambda - (12) MODIFIED SYNSPEC INPUT FOR'
C     P  ,' THE CURRENT LINE'
C        WRITE(6,'(A,A)')' abundances - (12) MODIFIED SYNSPEC INPUT FOR'
C     P  ,' THE CURRENT LINE'
C	WRITE(6,'(A,A)')' no.line - (9) ORDER  OF THE NEXT LINE AND '
C     P  ,'ABUNDANCE TO BE TREATED'
C        WRITE(6,'(A)')' line.dat - (8) DATA FOR THE CURRENT LINE'
C        WRITE(6,'(A)')' spectrum.20 - (20) SUBSIDIARY DUMMY FILE'
C	WRITE(6,'(A)')' makeinput.out - (10) DETAIL OUTPUT'
C
C	OPEN(3,FILE='model',STATUS='OLD')
	OPEN(7,FILE='element.dat',STATUS='OLD')
        OPEN(10,FILE='makeinput.out',STATUS='UNKNOWN')
        OPEN(11,FILE='hladaj.in',STATUS='OLD')
        OPEN(20,FILE='spectrum.20',STATUS='UNKNOWN')
	READ(7,'(/)')
        READ(7,*)IZMAZ,INTERP,NABUND
        READ(7,*)
	INTERP=0
        READ(7,*)(ABUND(I),I=1,NABUND)	
        READ(7,*)
C 	H ABUNDANCE, He ABUNDANCE
        READ(7,*)ABH,ABHEL
        READ(7,'(////)')
C 	ELEMENT ATOM NUMBER, MASS NUMBER
	READ(7,*)IAT,HMC
	PCP=IAT
C             8-IONIZ.POTENTIALS
        READ(7,*)
        READ (7,*)(ZIP(I),I=1,NION1-1)
        READ(7,*)
        READ(7,*)IPART
        READ(7,*)
        DO 5 J=1,NION1
         READ (7,*)(STA(I,J),I=1,6)
5       CONTINUE
C       LINE WIDTH - SPECTRUM INTERVAL CONTROLERS
        READ(7,*)
        READ(7,*)WIDTHL,WIDTHD,WIDTHO
C       ION, CHARACTERISTIC TEMPERATURES T1,T2
	I=1
        READ(11,'(//)')
10      READ(11,*,END=20)POM,CTEP(I,1),CTEP(I,3),CTEP(I,2)
        NION=I
        I=I+1
        GO TO 10
20	CONTINUE
        WRITE(20,'(A)')' THIS IS A SUBSIDIARY DUMMY ERROR FILE'
        WRITE(20,'(A)')' PRODUCED BY MAKEINPUT.F WHICH MUST NORMALLY'
        WRITE(20,'(A)')' BE OVERWRITTEN BY SYNSPEC'
	CLOSE(7)
	CLOSE(11)
        CLOSE(20)
C-----------------------------------------------------------------
C	      MODEL OF THE ATMOSPHERE (NEW KURUCZ)
C
C	DMHLB - MASS DEPTH COORDINATE
C	TEMP - TEMPERATURE
C	PRESS - GASS PRESSURE
C	EKONC - ELECTRON NUMBER DENSITY
C	AKONC - (ALL) ATOM NUMBER DENSITY
C
C	BOL=1.38062D-16
C	HJED=1.66053D-24
C	PLANK=6.626196D-27
	CLIGHT=2.997925D10
	INN='model'
        CALL AMODEL(INN,NDIM,NBOD,TEFF,GLOG
     P  ,DMHLB,HLB,TEMP,TLAK,EKONC,AKONC,DENS,ABROSS)
C
C	      MODEL OF THE ATMOSPHERE (HUBENY)
C
C	HDMHLB - MASS DEPTH COORDINATE
C	HTEMP - TEMPERATURE
C	HEKONC - ELECTRON NUMBER DENSITY
C	HAKONC - (ALL) ATOM NUMBER DENSITY
C     	NDPTH - NUMBER OF HUBENY'S DEPTH POINTS
	INN='model.hub'
        CALL HMODEL(INN,NDIM,NDPTH
     P  ,HDMHLB,HTEMP,HEKONC,HAKONC,HDENS)
C-----------------------------------------------------------------------
C	IKDM -CHARACTERISTIC KURUCZ DEPTHS
C       IHDM -CHARACTERISTIC HUBENY DEPTHS
        DO 80 IJ=1,NION
	  DO 70 ICHAR=1,3
            DO 60 I=1,NBOD
              IF (TEMP(I).GT.CTEP(IJ,ICHAR)) THEN
	        IKDM(IJ,ICHAR)=I
		GOTO 70
	      ENDIF
60          CONTINUE
	    IF (TEMP(NBOD).LT.CTEP(IJ,ICHAR))IKDM(IJ,ICHAR)=NBOD
70        CONTINUE
80      CONTINUE
C	??-TEMPERATURE IS NOT MONOTONUOSLY DECREASING UPWARDS 
C	IN NLTE MODEL (REVERSE THE CYCLE STARTING FROM THE BOTTOM)
        DO 110 IJ=1,NION
	  DO 100 ICHAR=1,3
            DO 90 I=1,NDPTH
              IF (HTEMP(I).GT.CTEP(IJ,ICHAR)) THEN
	        IHDM(IJ,ICHAR)=I
		GOTO 100
	      ENDIF
90          CONTINUE
            IF (HTEMP(NDPTH).LT.CTEP(IJ,ICHAR))IHDM(IJ,ICHAR)=NDPTH
100        CONTINUE
110      CONTINUE
C-----------------------------------------------------------------------
C		POLYNOMIAL PARTITION FUNCTION COEFFICIENTS FOR 
C		HI,HII   A    HEI,HEII,HEIII 
	DATA STAHI/-2.61655891D2,1.63428326D2,-4.06133526D1,5.03282928D0
     P	 ,-3.10998364D-1,7.66654594D-3,0.0D0,0.0D0,0.0D0,0.0D0,0.0D0
     P	 ,0.0D0/
	DATA STAHEI/-3.76575219D-1,2.33951687D-1,-5.79755525D-2
     P	 ,7.16333160D-3,-4.41302573D-4,1.08442997D-5,6.93147179D-1
     P	 ,9.29636701D-10,-2.30049742D-10,2.83829746D-11,-1.74590774D-12
     P	 ,4.28355287D-14,0.0D0,0.0D0,0.0D0,0.0D0,0.0D0,0.0D0/
C-----------------------------------------------------------------------
        DO 200 ID1=1,NBOD
	  SALA=DLOG(TEMP(ID1))
C		HIS - H PARTITION FUNCTION
	  DO 150 J=1,2
	    HIS(J)=DEXP(STAHI(1,J)+STAHI(2,J)*SALA+STAHI(3,J)*SALA**2.D0
     P	    +STAHI(4,J)*SALA**3.D0+STAHI(5,J)*SALA**4.D0
     P	    +STAHI(6,J)*SALA**5.D0)
150	  CONTINUE
C               HEIS - HE PARTITION FUNCTION
	  DO 160 J=1,3
	    HEIS(J)=DEXP(STAHEI(1,J)+STAHEI(2,J)*SALA+STAHEI(3,J)
     P	    *SALA**2.D0+STAHEI(4,J)*SALA**3.D0+STAHEI(5,J)*SALA**4.D0
     P	    +STAHEI(6,J)*SALA**5.D0)
160	  CONTINUE
C               HI - HI NUMBER DENSITY
C               HEI - HeI NUMBER DENSITY
	  HI(ID1)=1.D0/(1.D0+SAH(TEMP(ID1),EKONC(ID1),13.598D0,HIS(1)
     P	  ,HIS(2)))*AKONC(ID1)*ABH
	  HEI(ID1)=1.D0/(1.D0+SAH(TEMP(ID1),EKONC(ID1),24.587D0,HEIS(1)
     P	   ,HEIS(2))*(1.D0+SAH(TEMP(ID1),EKONC(ID1),54.416D0,HEIS(2)
     P	   ,HEIS(3))))*AKONC(ID1)*ABHEL
C	WRITE(10,*)' HI HeI NUMBER DENSITY',HI(ID1),HEI(ID1)
200 	CONTINUE
C-----------------------------------------------------------------
C	LINE DATA LIKE IN KURUCZ
C	DLL-LAMBDA IN [NM]  ,DLL0 IN [A], FREQ - FREQUENCY 1/S
C	STIO-DEGREE OF IONIZATION [1.-NEUTRAL]
C	BIJ-TRANSITION PROB. [1/SEK]=EINST.COEF
C	QJLOW-QUANTUM NUMBER J OF THE LOWER LEWEL [=>STAT.WEIGHT=2*J+1]
C	QJUP-QUANTUM NUMBER J OF THE UPPER LEWEL
C-----------------------------------------------------------------------
210	OPEN(9,FILE='no.line',STATUS='OLD')
        READ(9,*)
	READ(9,*,ERR=500)IPCL,IABUND,NLIN
	IF(NLIN.LE.0)GOTO 500
        WRITE(6,'(A28,2I5)')' CURRENT LINE AND ABUNDANCE:',IPCL,IABUND
 	CLOSE (9)
C		IPCL - ORDER OF THE LINE TO BE TREATED AS INPUT FOR
C	SYNSPEC AND ACCEL
C		IABUND - ORDER OF THE ABUNDANCE TO BE CONSIDERED
	OPEN(8,FILE='linelist',STATUS='OLD')
	IF (IPCL.GT.1)THEN
	  DO 260 I=1,IPCL-1
	    READ(8,*)
260	  CONTINUE
	  READ(8,*,ERR=310,END=500)DLL,COD,GF,ELO,QJLOW,EUP,QJUP
     P	  ,AGR,AGS,AGW,INEXT
	ELSE
	  READ(8,*,ERR=310,END=500)DLL,COD,GF,ELO,QJLOW,EUP,QJUP
     P	  ,AGR,AGS,AGW,INEXT
	ENDIF
	CLOSE (8)
	DLL0=DLL*10.D0
	FREQ=1.D7*CLIGHT/DLL
C        SVAHA=2.D0*QJLOW+1.D0
        STIO=(COD-DINT(COD))*100.D0+1.D0
C	  WRITE(6,*)'DINT NINT INT',DINT(COD),NINT(COD),INT(COD)
C	  BACHA DINT JE REAL*8, INT A NINT SU INTEGERY
	GOTO 320
310	WRITE(6,*)' ERROR IN THE LINE-LIST'
	PAUSE
320	CONTINUE
C-----------------------------------------------------------------------
C		WIDTH - INTERVAL/2 FOR THE SPECTRUM SYNTHESYS
C		STEP  - STEP FOR THE SPECTRUM SYNTHESYS
C		STEPN - NUMBER OF STEPS
	ION=INT(STIO+0.5D0)
C		FIRST DEPTH POINT TO DETERMINE STEP
	NHLB1=IKDM(ION,1)
	CALL GRCLAS(DLL0,HMC,TEMP(NHLB1),0.D0,GRC,DOP)
C	STEP [ANGSTREM]=(DOPPLER HW.+GAMA_RAD_CLAS/4/PI)/2 
	STEP=(DOP+GRC/4.D0/3.14D0)*DLL0*DLL0*1.D-8/CLIGHT/2.D0
        CUTOFF=DBLE(10000)*STEP
	IF(DLL0.GT.3647.D0)THEN
          CUTOFF=40.D0*DLL0/3647.D0
	ENDIF
C		SECOND DEPTH POINT TO DETERMINE WIDTH
	NHLB2=IKDM(ION,2)
	CALL UTLM(DLL0,EUP,PCP,HMC,STIO,ZIP(ION),
     P  HI(NHLB2),HEI(NHLB2),EKONC(NHLB2),TEMP(NHLB2),
     P  0.D0,AGR,GR,AGS,GS,AGW,GW,A,DOP,GAMAS)
C		+-WIDTH=FACTOR*(GAMA/4PI+DOPPLER HW.)
	WIDTH=GAMAS/4.D0/3.14D0+DOP
	IF(A.GT.1.D0)THEN
	  FACTOR=WIDTHL
	ELSE
	  FACTOR=WIDTHD
	ENDIF
	WIDTH=FACTOR*WIDTH*DLL0*DLL0*1.D-8/CLIGHT
        WRITE(10,'(A,F12.3,A,I2)')' WL [NM]=',DLL0/10.D0,'   ION=',ION
        WRITE(10,'(A,I3,A,I3)')' NHLB1=',NHLB1,'   NHLB2=',NHLB2
        WRITE(10,470)A,GR/GS,STEP,WIDTH,STEPN
C               MIDDLE DEPTH POINT TO DETERMINE 
C	LINE OPAC/CONTINUOUS OPACITY AND TO INCREASE THE WIDTH 
C	FOR STRONG LINES
	NHLB12=IKDM(ION,3)
        CALL OPAC(FREQ,TEMP(NHLB12),DENS(NHLB12),OPCON,ABROSS(NHLB12))
        CALL UTLM(DLL0,EUP,PCP,HMC,STIO,ZIP(ION),
     P  HI(NHLB12),HEI(NHLB12),EKONC(NHLB12),TEMP(NHLB12),
     P  0.D0,AGR,GR,AGS,GS,AGW,GW,A,DOP,GAMAS)
C             PARTITION FUNCTIONS AT NHLB12
C             STAVS(I,J) :  I-DEPTH POINT, J- ION
C	IAT=INT(PCP+0.5D0)
        IF(IPART.EQ.1)THEN
          CALL PFDWOR(NHLB12,NDIM,NBOD,NION1,NION,IAT,TEMP,EKONC,STAVS)
        ELSE
          CALL PFIRW(NHLB12,NDIM,NBOD,NION1,NION,STA,TEMP,STAVS)
        ENDIF
	PFION=STAVS(NHLB12,ION)
        WRITE(10,'(A,I3)')' NHLB12=',NHLB12
C        CALL AIONIZ(NHLB12,NDIM,NBOD,NION1,NION,ZIP,STAVS,STAV,ZI,SA
C     P  ,F1T,TEMP,EKONC,DMHLB)
C       RR(I,J)= POPULATION OF THE J-TH ION AT I-TH DEPTH/TOTAL
C       ELEMENT POPULATION (IONIZATION FRACTION)
C       R1(J)= N(J)/N(1)
C       RION(J)= N(J)/N(J-1)
        CALL ZASTUP(DMHLB,TEMP,EKONC,ZIP,STAVS,RR,RION,R1,NDIM,NBOD
     P  ,NION1,NION,NHLB12)
C        ENION=ABUND(IABUND)*AKONC(NHLB12)
	ENION=RR(NHLB12,ION)*ABUND(IABUND)*AKONC(NHLB12)*ABH
        CALL OPACL(FREQ,GF,ELO,TEMP(NHLB12),DOP,ENION,PFION,GAMAS,OPLIN)
	RATIO=OPLIN/OPCON
	WRITE(10,460)OPLIN,OPCON,RATIO
460     FORMAT(' OPLIN=',E8.2,' OPCON=',E8.2,
     P  ' RATIO=',E8.2)
        IF(RATIO.GT.(1.D0/WIDTHO))THEN
          WIDTH2=DLL0/FREQ*GAMAS/4.D0/3.14D0*SQRT(WIDTHO*RATIO-1.D0)
          IF(WIDTH2.GT.WIDTH)THEN
            WIDTH=WIDTH2
          ENDIF
        ENDIF
	STEPN=2.D0*WIDTH/STEP
	IF(STEPN.LT.40)THEN
	  STEP=STEP/1.5D0
	  WIDTH=1.5D0*WIDTH
          STEPN=2.25D0*STEPN
	ENDIF
	IF(STEPN.GT.1000)THEN
	  STEP=STEP*1.5D0
          STEPN=STEPN/1.5D0
	ENDIF
C        CUTOFF=DBLE(5000)*DOP*DLL0/FREQ
	WRITE(10,470)A,GR/GS,STEP,WIDTH,STEPN
470	FORMAT(' A=',E8.2,' GR/GS=',E8.2,
     P  ' STEP=',F7.4,' WIDTH=',F8.3,' N=',F7.0)
	OPEN(8,FILE='line.dat',STATUS='UNKNOWN')
        WRITE(8,270)DLL,COD,GF,ELO,QJLOW,EUP,QJUP
     P  ,AGR,AGS,AGW,INEXT,RATIO,STEPN
270     FORMAT(F10.4,F6.2,1X,F7.3,F12.3,F5.1,F13.3,F5.1,3F7.2,I2
     P  ,E10.2,F7.0)
	CLOSE (8)
C-----------------------------------------------------------------------
        OPEN(2,FILE='lambda0',STATUS='OLD')
	OPEN(12,FILE='lambda',STATUS='UNKNOWN')
C	OVERWRITE AND SET THE APPROXIMATE STANDARD DEPTH OF 
C	HUBENY'S MODEL ACCORDING ION MAXIMAL POPULATION 
C	IN KURUCZ MODEL!
        READ(2,*)IMODE,IDSTD,IPRINT
	IDSTD=IHDM(ION,3)
        IF (IDSTD.LT.46)IDSTD=46
        WRITE(12,'(3I5)')IMODE,IDSTD,IPRINT
 	DO 480 I=1,4
          READ(2,'(A100)')A100
	  WRITE(12,'(A100)')A100
480 	CONTINUE
        READ(2,*)ZMAZ,ZMAZ,IZMAZ,IZMAZ,RELOP
        WRITE(12,'(2F11.3,2F9.2,D8.1,F7.4)')DLL0-WIDTH,DLL0+WIDTH,
     P  CUTOFF,CUTOFF,RELOP,STEP
        READ(2,'(A100)')A100
        WRITE(12,'(A100)')A100
        CLOSE (2)
        CLOSE (12)
C
        OPEN(2,FILE='abundances0',STATUS='OLD')
        OPEN(12,FILE='abundances',STATUS='UNKNOWN')
        READ(2,*)NUPTO
        WRITE(12,'(I3)')NUPTO
        DO 490 I=1,NUPTO
          READ(2,*)IEL,ABIEL
	  IF(I.EQ.IAT)ABIEL=ABUND(IABUND)
          WRITE(12,'(I3,E11.3)')IEL,ABIEL
490     CONTINUE
        CLOSE (2)
        CLOSE (12)
C
        OPEN(9,FILE='no.line',STATUS='UNKNOWN')
        WRITE(9,'(A)')'#NEXT LINE, NEXT ABUNDANCE, TOTAL NO. OF LINES'
	IF(IPCL.EQ.NLIN)THEN
          WRITE(9,'(3I7)')1,IABUND+1,NLIN
	ELSE
          WRITE(9,'(3I7)')IPCL+1,IABUND,NLIN
	ENDIF
        CLOSE (9)
        CLOSE (10)
	STOP
C-----------------------------------------------------------------------
500	CLOSE (8)
        OPEN(9,FILE='no.line',STATUS='UNKNOWN')
        WRITE(9,'(A)')'#NEXT LINE, NEXT ABUNDANCE, TOTAL NO. OF LINES'
        WRITE(9,'(A)')'ERROR AT THE END OF LINELIST'
        CLOSE (9)
        CLOSE (10)
	STOP
	END
C-----------------------------------------------------------------------
	SUBROUTINE UTLM(DL0,EP,S,AM,Z,CHI,HI,HEI,EKONC,TEMP,VT,
     P  AGR,GR,AGS,GS,AGW,GW,A,DOP,GAMAS)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	     DL0   -LINE CENTER [ANGSTREM]			       C
C	     EP    -EXCIT.POTENTIAL OF UPPER LEWEL [1/CM]	       C
C	     S	   -ATOM NUMBER 				       C
C	     AM    -MASS NUMBER 				       C
C	     Z	   -IONIZATION DEGREE, Z=1. FOR NEUTRAL STATE...       C
C	     CHI   -IONIZ. POTENTIAL OF THE ION [EV] 		       C
C	     HI    -NEUTR. HYDROGEN NUMBER DENSITY [CGS]	       C
C	     HEI   -NEUTR. HELIUM NUMBER DENSITY [CGS]		       C
C	     EKONC -ELECTRON NUMBER DENSITY [CGS]		       C
C	     TEMP  -TEMPERATURE [KELVIN]			       C
C	     VT    -TUBULENT VELOCITY [CGS]	 		       C
C	     GR    -RADIATIVE DAMPING CONSTANT			       C
C	     GS    -STARK  DAMPING CONSTANT			       C
C	     GW    -VAN DER WAALSOV  DAMPING CONSTANT		       C
C								       C
C	     OUTPUT:                                                   C
C		A   -  DAMPING PARAMER                                 C
C		DOP - DOPLER. HALF-WIDTH[1/S]                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	C=2.997925D10
	DLL0=1.E-8*DL0
	BOL=1.380622D-16
C	     RADIATIVE DAMPING
	IF(AGR.GT.0.D0)THEN
	  GR=DEXP(2.302585D0*AGR)
	ELSE
	  GR=2.4734D-22*C*C/DLL0/DLL0
C	     V PRIPADE AK POZNAS SIRKU AUTOIONIZACNEJ HLADINY GRA
C	     V [EV] => GR=1.52E12*GRA
	ENDIF
	EFF2=Z*Z*13.595D0/(CHI-EP/8065.9D0)
	IF(EFF2.LT.0.D0.OR.EFF2.GT.25.D0)EFF2=25.D0
C	      STARK DAMPING 
C	 IF(CHI.LE.EP/8065.9D0) THEN
C	     AUTOIONIZ. HORNA HLADINA ? =>BERIEME JU AKO EFF2=25
C            AJ VO VAN DER WAALSOVOM PRE S<20 (AT.CISLO)
C	   EFF2=0.D0
C	 ENDIF
	IF(AGS.NE.0.D0)THEN
	  GS=DEXP(2.302585D0*AGS)
	ELSE
	  GS=1.0D-8*EFF2**2.5D0
	ENDIF
	GS=GS*EKONC
C	     VAN DER WAALSOV DAMPING 
	IF (INT(S).LT.21.OR.INT(S).GT.28)THEN
          R2=2.5D0*EFF2*EFF2/Z/Z
	ELSE
	  R2=(45.D0-S)/Z
	ENDIF
	IF(AGW.NE.0.D0)THEN
	  GW=DEXP(2.302585D0*AGW)
	ELSE
	  GW=4.5D-9*R2**0.4D0
	ENDIF
	GW=GW*(HI+0.42D0*HEI)*(TEMP/1.D4)**0.3D0
C	     DOPL.HAFWIDTH [1/SEK]
	DOP=DSQRT(2.D0*BOL*TEMP/(AM*1.672614D-24)+VT*VT)/DLL0
C	     FRAME DAMPING PARAMETER
	GAMAS=GR+GS+GW
	A=GAMAS/(4.D0*3.1415926D0*DOP)
	RETURN
	END
C-----------------------------------------------------------------------
	SUBROUTINE GRCLAS(DL0,AM,TEMP,VT,GR,DOP)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	     DL0   -LINE CENTER [ANGSTREM]			       C
C	     AM    -MASS NUMBER 				       C
C	     TEMP  -TEMPERATURE [KELVIN]			       C
C	     VT    -TUBULENT VELOCITY [CGS]      		       C
C								       C
C	     OUTPUT:                                                   C
C		GR  - CLASSICAL RADIATIVE DAMPING CONSTANT             C
C		DOP - DOPLER. HALF-WIDTH[1/S]                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	C=2.997925D10
	DLL0=1.E-8*DL0
	BOL=1.380622D-16
C	     RADIATIVE DAMPING
	  GR=2.4734D-22*C*C/DLL0/DLL0
C	     V PRIPADE AK POZNAS SIRKU AUTOIONIZACNEJ HLADINY GRA
C	     V [EV] => GR=1.52E12*GRA
C	     DOPL.HAFWIDTH [1/SEK]
	DOP=DSQRT(2.D0*BOL*TEMP/(AM*1.672614D-24)+VT*VT)/DLL0
	RETURN
	END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        SUBROUTINE OPAC (FREQ,TEMP,DENS,CHI,ABROSS)
C       TO ESTIMATE MONOCHROM. CHI_{\NU} OPACITY [CM^-1]
C       AFTER BORSENBERG ET AL., 1979, AA 76, 287
C       FREQ - FREQUENCY [1/S]
C       TEMP - TEMPERATURE [K]
C       DENS - DENSITY [CGS]
C       ABROSS - ROSSELAND MEAN OPACITY [CM^2/G]
C       OPAC - MONOCHROM. OPACITY [CM^-1]
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        PLANK=6.626196D-27
        BOL=1.38062D-16
        T4=TEMP*1.D-4
        AK10=2.D0*DEXP(8.79D0/T4)
        IF(T4.GT.2.D0) THEN
          AK1=DMAX1(5.D0*2.D0**(15.D0/T4-4.D0),1.D0)*ABROSS
          AK0=AK1/AK10
        ELSE
          AK0=20.D0*(1.8D0-0.4D0*T4)*(T4/15.D0)**2.D0*ABROSS
          AK1=AK0*AK10
        ENDIF
        HNU=PLANK*FREQ
        U=HNU/BOL/TEMP
C       IN [EV]   
        HNU=6.241507D11*HNU
        IF(HNU.GT.13.598D0)THEN
          CHI=AK1
        ELSE
          CHI=AK0*(13.598D0/HNU)*(13.598D0/HNU)
        ENDIF
C       IN [CM^-1]
        CHI=CHI*DENS
C        WRITE(2,*)' U , OPAC',U,CHI
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE OPACL (FREQ,GF,ELO,TEMP,DOP,ENION,PFION,GAMAS,OPAC)
C       TO ESTIMATE MONOCHROM. CHI_{\NU} LINE OPACITY [CM^-1]
C       AT THE LINE CENTER FOR PURE LORENTZ PROFILE
C       FREQ - FREQUENCY [1/S]
C	GF - LOG GF
C	ELO - LOWER ENERGY LEVEL [1/CM]
C       TEMP - TEMPERATURE [K]
C	DOP - DOPLER HALFWIDTH [1/S]
C	ENION - ION NUMBER DENSITY [CGS]
C	PFION - ION PARTITION FUNCTION
C	GAMAS - SUM OF THE DAMPING CONSTANTS
C       OPAC - MONOCHROM. OPACITY [CM^-1]
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	PI=3.1415926D0
	E=4.80325D-10
	EME=9.1096D-28
        CLIGHT=2.997925D10
        PLANK=6.626196D-27
        BOL=1.38062D-16
C		ALOR0-NORMALIZED LORENTZ PROFILE AT THE LINE CENTER
	ALOR0=4.D0/GAMAS
C		AV0-NORMALIZED VOIGH PROFILE AT THE LINE CENTER
C	DLL0=CLIGHT/FREQ*1.E8
C       A=GAMAS/(4.D0*PI*DOP)
C	AV0=VOIGT(DLL0,DLL0,A,DOP)/DSQRT(PI)/DOP
	AGF=DEXP(2.302585D0*GF)
	POM=PI*E*E/EME/CLIGHT*AGF
	STIM=1.D0-DEXP(-PLANK*FREQ/TEMP/BOL)
	BOLT=DEXP(-1.43879*ELO/TEMP)
	OPAC=POM*STIM*ENION/PFION*BOLT*ALOR0
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE AMODEL(INN,NM1,ND0,TEF,GLOG
     P  ,VDM,VHLB,VTEMP,VTLAK,VEKONC,VAKONC,VDENS,ABROSS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION VHLB(NM1),VAKONC(NM1),VEKONC(NM1),VTLAK(NM1)
     p  ,VTEMP(NM1),VDM(NM1),VDENS(NM1),ABROSS(NM1)
        CHARACTER*30 INN
C
C             MODEL OF THE ATMOSPHERE (NEW KURUCZ)
C
C       DM - MASS DEPTH COORDINATE
C       HLB - GEOMETRICAL DEPTH
C       TEMP - TEMPERATURE
C       TLAK - GASS PRESSURE
C       EKONC - ELECTRON NUMBER DENSITY
C       AKONC - (ALL) ATOM NUMBER DENSITY
C       DENS - DENSITY
C       ABROSS - ROSS.MEAN OPACITY [CM^2/G]
C
        OPEN(3,FILE=INN,STATUS='OLD')
        READ(3,30) TEF,GLOG
        READ(3,35) ND0
30      FORMAT(4X,F8.0,9X,F8.5)
35      FORMAT(/////////////////////10X,I3)
        BOL=1.38062D-16
C               WMM=SUM_e (M_e*ABUNDANCE_e)  IS MEAN ATOM MASS
C       ABUNDANCE_e IS N_e/AKONC
        WMM=2.2034D-24
        VHLB(1)=0.D0
        DO 40 I=1,ND0
          READ(3,*)VDM(I),VTEMP(I),VTLAK(I),VEKONC(I),ABROSS(I)
          VAKONC(I)=VTLAK(I)/VTEMP(I)/BOL
          VAKONC(I)=VAKONC(I)-VEKONC(I)
          VDENS(I)=VAKONC(I)*WMM
          IF(I.GT.1) THEN
            DELTA=2.D0*(VDM(I)-VDM(I-1))/(VDENS(I)+VDENS(I-1))
            VHLB(I)=DELTA+VHLB(I-1)
          ENDIF
40      CONTINUE
        CLOSE(3)
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE HMODEL(INN,NM1,NDPTH
     P  ,DEPTH,TEMP,ELEC,AKONC,DENS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION DEPTH(NM1),TEMP(NM1),ELEC(NM1),
     P  AKONC(NM1),DENS(NM1),X(500)
        CHARACTER*30 INN
C
C             MODEL OF THE ATMOSPHERE (HUBENY)
C
C       DEPTH - MASS DEPTH COORDINATE
C       TEMP - TEMPERATURE
C       ELEC - ELECTRON NUMBER DENSITY [CGS]
C       AKONC - (ALL) ATOM NUMBER DENSITY [CGS]
C       DENS - DENSITY [CGS]
C
C               WMM=SUM_e (M_e*ABUNDANCE_e)  IS THE MEAN ATOM MASS
C       WHERE ABUNDANCE_e IS N_e/AKONC
C       FOR 90% H + 10 % HE  :
        WMM=2.2034D-24
        OPEN(3,FILE=INN,STATUS='OLD')
        READ(3,*) NDPTH,NUMPAR
        READ(3,*) (DEPTH(I),I=1,NDPTH)
        DO 30 ID=1,NDPTH
          READ(3,*) (X(I),I=1,NUMPAR)
          TEMP(ID)=X(1)
          ELEC(ID)=X(2)
          DENS(ID)=X(3)
          AKONC(ID)=DENS(ID)/WMM
C          write(9,'(4e11.4)')depth(id),temp(id),elec(id),dens(id)
30      CONTINUE
        CLOSE(3)
        RETURN
        END
C-----------------------------------------------------------------------
	SUBROUTINE PFIRW(NHLB,NDIM,NBOD,NION1,NION,STA,TEMP,STAVS)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION STA(6,NION1),STAVS(NDIM,NION1),TEMP(NDIM)
C	PARTITION FUNCTIONS AFTER IRWIN A.W, 1981,APJSS 45, 621
        I=NHLB
	  DO 70 J=1,NION
	    IF (ABS(STA(1,J)-0.D0).LT.1.D-30) GO TO 60
	    SALA=DLOG(TEMP(I))
	    ARG=STA(1,J)+STA(2,J)*SALA+STA(3,J)*SALA*SALA+
     P      STA(4,J)*SALA**3.D0+STA(5,J)*SALA**4.D0+STA(6,J)*SALA**5.D0
	    STAVS(I,J)=DEXP(ARG)
	    GO TO 70
60	    STAVS(I,J)=1.D0
70	  CONTINUE
       WRITE (10,'(A,A)')' TEMP    STAVS1    STAVS2    STAVS3    STAVS4'
     P,'    STAVS5    STAVS6    STAVS7    STAVS8    STAVS9'
	WRITE(10,130)TEMP(I),(STAVS(I,J),J=1,NION)
130       FORMAT(F7.0,20E10.3) 
	RETURN
	END
C-----------------------------------------------------------------------
        subroutine potlow(TEMP,ANE,EPLOW)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c       TEMP - Temperature[K]
c       ane - electron number density [cm^{-3}]
c       lowering of the ionization potential for neutrals, z=1 in [eV]
c       for ions(z):      eplow(z)=z*eplow(1)
        BOL=1.38062D-16                      
        PI=3.14159D0
        e=4.80325d-10
        pom=bol*TEMP/8.d0/pi/ane
c       debye lenght in [CGS]
        debye=sqrt(pom)/e
        eplow=1.44d-7/debye
        RETURN
        END
C-----------------------------------------------------------------------
	SUBROUTINE PFDWOR(NHLB,NDIM,NBOD,NION1,NION,IAT,TEMP,EKONC
     P  ,STAVS)
c
c       partition functions after:
c       M.M.Dworetsky & B. Smalley, private communication
c
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DIMENSION STAVS(NDIM,NION1),EKONC(NDIM),TEMP(NDIM),U(5)
C        DO 80 I=1,NBOD
	I=NHLB
          CALL POTLOW(TEMP(I),EKONC(I),EPLOW)
          THETA=5039.77D0/TEMP(I)
C		PARTFN IS IN 'pfdwor.inc'
          CALL PARTFN(IAT,THETA,U,EPLOW)
          DO 70 J=1,NION
	    IF(J.LE.5)THEN
	      STAVS(I,J)=U(J)
	    ELSE
	      STAVS(I,J)=1.D0
	    ENDIF
70        CONTINUE
C80      CONTINUE
       WRITE (10,'(A,A)')' TEMP    STAVS1    STAVS2    STAVS3    STAVS4'
     P,'    STAVS5    STAVS6    STAVS7    STAVS8    STAVS9'
C        DO 140 I=1,NBOD
         WRITE(10,130)TEMP(I),(STAVS(I,J),J=1,NION)
130       FORMAT(F7.0,20E10.3)
C140     CONTINUE
        RETURN
        END
C-----------------------------------------------------------------------
        SUBROUTINE ZASTUP(DM,TEMP,EKONC,ZIP,STAVS,RR,RION,R1,NDIM,NBOD
     P  ,NION1,NION,NHLB12)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION ZIP(NION1-1),STAVS(NDIM,NION1)
     P  ,DM(NDIM),TEMP(NDIM),EKONC(NDIM)
     P  ,RION(NION1),R1(NION1),RR(NDIM,NION1)
        DO 10 J=1,NION1
          DO 5 I=1,NBOD
            RR(I,J)=1.D-31
5         CONTINUE
10      CONTINUE
        DO 40 I=1,NBOD
          RION(1)=1
          R1(1)=1
          SUM1=1.D0
          DO 20 J=2,NION
            RION(J)=SAH(TEMP(I),EKONC(I),ZIP(J-1),STAVS(I,J-1)
     P      ,STAVS(I,J))
            R1(J)=R1(J-1)*RION(J)
            SUM1=SUM1+R1(J)
20        CONTINUE
          DO 30 J=1,NION
            RR(I,J)=R1(J)/SUM1
30        CONTINUE
40      CONTINUE
         WRITE(10,'(A,40I11)')' DM',(I,I=1,NION)
C        DO 50 I=1,NBOD
	I=NHLB12
          WRITE(10,130)DM(I),(RR(I,J),J=1,NION)
130       FORMAT(40(D10.3,1X))
C50      CONTINUE
        RETURN
        END
C-----------------------------------------------------------------------
	DOUBLE PRECISION FUNCTION SAH(TE,EK,ZP,S1,S2)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C             SAHA EQUATION (RATIO OF THE TWO NEIGHBOUR ION NUMBER 
C	DENSITIES)
C             ZP -IV [EV],BOLT.CONST.-IN [ERG/K]
	SAH=1.2020D9*S2/(S1*(5039.77D0/TE)**2.5D0
     P  *DEXP(2.302585D0*5039.77D0/TE*ZP)*EK*TE*1.38062D-16)
        RETURN
        END
C-----------------------------------------------------------------------
        DOUBLE PRECISION FUNCTION VOIGT(DL,DL0,A,DOP)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C        REAL*8 VOIGT0
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C            DL  - CHOOSEN LAMBDA [ANGSTROM]                           C
C            DL0 - LINE CENTER [ANGSTROM]                              C
C            A   - DAMPING PARAMETER                                   C
C            DOP - DOPLER. HALFWIDTH [1/S]                             C
C                                                                      C
C            OUTPUT - VOIGT PROFIL                                     C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        C=2.997925D10
        X=1.D8*(C/DL-C/DL0)/DOP
        POM=A
        VYST=VOIGT0(X,POM)
        VOIGT=VYST
        RETURN
        END   
C-----------------------------------------------------------------------
        DOUBLE PRECISION FUNCTION VOIGT0(X,Y)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
C      IMPLICIT REAL*8 (A-H,O-Z)
C      REAL*8 VOIGT0
C      REAL*4 X,Y   
C   HUMLICEK VOIGT FUNCTION ALGORITHM  (LOWER PRECISION VERSION)
      DIMENSION T(6),C(6),S(6)
                DATA T/.314240376,.947788391,1.59768264,2.27950708,3.020
     /63703,3.8897249/,           C/1.01172805,-.75197147,1.2557727E-2, 
     /1.00220082E-2,-2.42068135E-4,5.00848061E-7/,           S/1.393237,
     /.231152406,-.155351466,6.21836624E-3,9.19082986E-5,-6.27525958E-7/
      WR=0.
      Y1=Y+1.5
      Y2=Y1*Y1
      DO 3 I=1,6
      R=X-T(I)  
      D=1./(R*R+Y2)
      D1=Y1*D
      D2=R*D 
      R=X+T(I)
      D=1./(R*R+Y2)
      D3=Y1*D
      D4=R*D 
      WR=WR+C(I)*(D1+D3)-S(I)*(D2-D4)
    3 CONTINUE
      VOIGT0=DBLE(WR)
      RETURN
      END   
C-----------------------------------------------------------------------
	INCLUDE 'pfdwor.inc'
